data MySchool;
infile datalines missover;
input @1 name $char7.
      @9 sex  $char1.
	  @13 age 2.
	  @17 height 4.1
	  @22 weight 5.1;
/*123456789012345678901234567890*/
Datalines;
Joy     F   11  51.3  50.5
Jane    F   12  59.8  84.5
Jim     M   12  57.3  83.0
Alice   F   13  56.5  84.0
Jeff    M   13  62.5  84.0
Bob    	M  	14	64.2  90.0
Philip  M   16  72.0 150.0
;
run;

data Extra;
infile datalines missover;
input 
      @1 name $char7.
      @10 Allergies  $char4.
	  @16 Diet $char13.
	  @31 sports $char3.
	  @37 Resident_day $char8.;
/*34567890123456789012345678901234567890123456789*/
datalines;
Joyce    None  Vegan          No    Resident	
Jane     Nuts  Omnivore       No    Day
James    None  Omnivore       No    Resident
Alice    Nuts  NoMeat         Yes   Resident
Jeffrey  Dust  Vegan          No    Day
Philip   None  NoMeat         Yes   Resident
;
run;



data ExtraINfo;
infile datalines missover;
input 
      @1 name $char7.
	  @8 Sex $char1.
	  @10 Age 2.
      @13 Allergies  $char4.
	  @19 Diet $char6.
	  @27 sports 1.
	  @31 Resident_day $char8.;
/*34567890123456789012345678901234567890123456789*/
/*Name  Sex Allerg. Diet      Sport  ResDay*/
datalines;
Joy    F 11 None  Vegan   3   Resident
Jane   F 12 Nuts  Meat    1   Day
Jim    M 12 None  Meat    0   Resident
Jeff   M 13 Dust  Vegan   1   Day
Philip M 16 None  NoMeat  2   Resident
;
run;
proc print; run;

/******************************************************************
Section __:
*******************************************************************/
Proc SQL; select Name, sex, count(*), Height, avg(height), weight/2.2 as Wt_KG
 from MyClass
   where sex="M" 
		and calculated Wt_KG gt 38
   group by sex
  having substr(name,1,2) NE "Bo" 
    and  Height/avg(height) Gt .95;

/******************************************************************
Section __:
*******************************************************************/
 Proc SQL;
 Select Count(*), avg(age)                       ,sum(age)
 From MYClass;


/******************************************************************
Section __:
*******************************************************************/
 Proc SQL;
Select Name, count(*) , sex,   avg(height)
 From MYClass  Where age > 11
 Group by Sex
 Having Substr(name,1,1)='J'   and height GT avg(height);



 /******************************************************************
Section __:
*******************************************************************/
* find the boys who are of the same age as the boy playing the max # of sports;
* find the Girls who are of the same age as the Girl playing the max # of sports;
options nocenter;
Proc SQL;
select name , sex, age 
from MySchool as O
where O.Age =(select Age from ExtraInfo as I
              where O.sex=I.sex 
			having I.Sport=max(Sport));

			 Proc SQL;
select name , sex, age 
from MySchool as O
where O.Age =(select Age from ExtraInfo as I
            Where I.Sex EQ O.Sex 
			Having Sports=Max(sports)     
			);

			 Proc SQL;
select name , sex, age 
from MySchool as O
where exists   (select * from ExtraInfo as I       having  I.age   =   O.age     and       I.sex  NE O.Sex)  ;

