************;
data MyClass;
set sashelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
run;

Proc SQL number;
Create table BasicSyntax as
Select 	Name ,sex ,Age 	,Avg(AGE) as AvgAge
From MyClass
Where age GE 14
Group by Sex
having AvgAge GT 14.5
Order by sex, name;

options nocenter;
proc print data=BasicSyntax;
run;


****Create var with mult********;
Proc SQL;
Create Table BasicSyntax2 As
Select 	Name  ,Age 	
From MyClass;

options nocenter;
proc print data=BasicSyntax2;
run;

***Case*********;
Proc SQL;
Create Table Basic_syntax4 As
Select 	Name  ,	Age , 
  Case /*Structure 1 - works*/
   When Sex="M" and age LE 14 then "M LE 14"
   when Sex="M"               then "M GT 14"
   When Sex="F" and age LE 14 then "F LE 14"
   when Sex="F"               then "F GT 14"

	else  "ODD"
   end as AgeGrp	
From MyClass
;


Proc SQL;
Create Table Basic_syntax4 As
Select 	Name  ,	Age , 
  Case /*Structure 1 - works with height variable*/
   When Sex="M" and age LE 14 then "M LE 14"
         when height=72 then "6 foot Tall"
   when Sex="M"               then "M GT 14"
   When Sex="F" and age LE 14 then "F LE 14"
   when Sex="F"               then "F GT 14"

	else  "ODD"
   end as AgeGrp	
From MyClass
;

options nocenter;

Proc SQL;/**SECOND VERION OF THE CASE****/
Create Table Basic_syntax4A As
Select 	Name  ,	Age , 
  Case sex   /*case structure 2 works*/
   when "M" then "Boy"
   when "F" then "Girl"
   else  "ODD"
   end as Gender	
From MyClass
;

OPTIONS NOCENTER;
Proc SQL;/**SECOND VERION OF THE CASE****/
Create Table Basic_syntax4B As
Select 	Name  ,	Age , 
  Case age
   when EQ 15 then "Older"
   else  "Error"
   end as AgeGroup	
From MyClass
;

Proc SQL;/**SECOND VERION OF THE CASE****/
Create Table Basic_syntax4B As
Select 	Name  ,	Age , 
  Case age
   when GT 15 then "Older"
   when LE 15 then "Younger"
   else  "Error"
   end as AgeGroup	
From MyClass
;

Proc SQL;/**SECOND VERION OF THE CASE****/
Create Table Basic_syntax4B As
Select 	Name  ,	Age , 
  Case age
   when  = 14 then "Older"
   when  = 13 then "Younger"
   else  "Error"
   end as AgeGroup	
From MyClass
;

Proc SQL;/**SECOND VERION OF THE CASE****/
Create Table Basic_syntax4B As
Select 	Name  ,	Age , 
  Case age
   when 15 then "Older"
   when 14 then "Younger"
   else  "Error"
   end as AgeGroup	
From MyClass
;

/********Sorting*****************/
Proc SQL;/**sorting****/
Create Table Basic_syntax5 As
Select 	Name, sex  ,	Age 
From MyClass 
order by sex, name

;quit;

Proc SQL;/**sorting****/
Create Table Basic_syntax5A As
Select 	Name  ,	Age 
From MyClass 
order by sex, name

;quit;

/******************************************************************
Section __:  Summarizing
*******************************************************************/
/********Summarizing*****************/
Proc SQL;/**Summarizing****/
Create Table Basic_syntax6A As
Select 	name, age, height
  ,sum(age,height) as SummingRows    

From MyClass; 
quit;

Proc SQL;/**Summarizing****/
Create Table Basic_syntax6 As
Select 	sum(age) as SumAge
            , avg(age) as AvgAge    
From MyClass 
;quit;

Proc SQL;/**Summarizing****/
Create Table BasicSyntax6a As
Select 	sum(age), avg(age), count(*), count(sex="F"), count(sex="M") 
From MyClass 
;quit;

proc print data=BasicSyntax6a;run;

Proc SQL;/**Summarizing****/
Create Table BasicSyntax6B As
Select 	sum(age), avg(age), count(*), Sum(sex="F"), Sum(sex="M") 
From MyClass 
;quit;

Proc SQL;/**Summarizing****/
Create Table BasicSyntax6c As
Select 	avg(age) as AvgAge, count(*) as NmbrSubj, 
		Sum(sex="F") as NmbrF, Sum(sex="M") as NmbrM 
From MyClass 
;quit;

OPTIONS NOCENTER;
Proc SQL;/**Summarizing****/
/*Create Table BasicSyntax6c As*/
Select 	avg(age) as AvgAge 
		,Sum((sex="F")*age)    as SmFemAges
        ,Sum((sex="M")*Weight) as SmMaleWt
From MyClass 
;quit;

/******************************************************************
Section __: Grouping
*******************************************************************/
Proc SQl;
/*create table  BasicSyntax7  as*/
select avg(age) as AvgAge
	, min(age) as MinAge
	, max(age) as MaxAge
 from MyClass
;
 run;


Proc SQl;
/*create table  BasicSyntax7A as*/
select sex, avg(age) as AvgAge
	, min(age) as MinAge
	, max(age) as MaxAge
 from MyClass
 Group by sex
 order by sex desc;
 run;


Proc SQl;
create table  BasicSyntax7B as
select                    avg(age) as AvgAge
	, min(age) as MinAge
	, max(age) as MaxAge,  count(*)
 from MyClass
 Group by sex;
 run;

 /******************************************************************
Section __: Filtering where and having
*******************************************************************/
/**where****/
proc SQL;
create table BasicSyntax8 as
select name, age 
 from MyClass
 where substr(name,1,1) in ("J","M");

quit;


proc SQL;
create table BasicSyntax8A as
select name, age 
 from MyClass
 where substr(name,1,1) in ("A","J","M") and age GT 14;

quit;

/**Having****/
proc SQL;
create table BasicSyntax8B as
select age, avg(height) as AvgHgt
 from MyClass
 group by age
 having AvgHgt GT 59.5;
quit;
