/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

proc SQL _method _tree; 
select  left(put(sum(sex="F"),2.0) ) as FemCount
	   ,left(put(sum(sex="M"),2.0) ) as MaleCount
       ,avg(height) as AllAvgHeight
       ,avg(age)   as AllAvgAge
       ,sum(height*(sex="F"))/sum(sex="F") as FemAvgH
	   ,sum(height*(sex="M"))/sum(sex="M") as MaleAvgH  
       ,sum(Age*(sex="F"))/sum(sex="F")    as FemAvgAge
	   ,sum(Age*(sex="M"))/sum(sex="M")    as MaleAvgAge  
into   :FemCount             ,:MaleCount 
       ,:AllAvgHeight        ,:AllAvgAge 
       ,:FemAvgH             ,:MaleAvgH  
       ,:FemAvgAge           ,:MaleAvgAge
  from MyClass 
;
%put _user_;
title1 "AllAvgAge=&AllAvgAge  and  AllAvgHeight=&AllAvgHeight";
title2 "FemAvgAge=&FemAvgAge  and MaleAvgAge=&MaleAvgAge";
title3 "FemAvgH=&FemAvgH     and MaleAvgH=&MaleAvgH";
title4 "FemCount=&FemCount   and   MaleCount=&MaleCount";


%put _user_;
title1 "AllAvgAge=&AllAvgAge &  FemAvgAge=&FemAvgAge & MaleAvgAge=&MaleAvgAge" ; 
title2 " AllAvgHeight=&AllAvgHeight & FemAvgH=&FemAvgH   & MaleAvgH=&MaleAvgH";
title3 "FemCount=&FemCount   and   MaleCount=&MaleCount";

options nocenter;
Proc SQl;
select name, age
from MyClass
where Sex ="F";


options nocenter;
Proc SQl;
select 
name Label='StuNme'
, age Label='StuAge'
from MyClass
where Sex ="F";

Proc SQl;
create table fancy as
select 
name Label='StuNme'
, age Label='StuAge'
from MyClass
where Sex ="F";
proc print data=fancy label;
run;



/******************************************************************
Section __:
*******************************************************************/
Proc SQl;
select 
name Label="#"
, age Label="#"
from MyClass
where Sex ="F";

Proc SQl;
create table fancy as
select 
name Label='#'
, age Label='#'
from MyClass
where Sex ="F";

proc print data=fancy label;
run;

/******************************************************************
Section __:
*******************************************************************/
Proc SQl;
select 
name Label="#"
, age Label="#" format=6.3
from MyClass
where Sex ="F";


Proc SQl;
create table fancy as
select 
name 
, age format=6.3
from MyClass
where Sex ="F";

proc print data=fancy label;
run;
