/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

proc SQL;
create table eligable
(ssn num
 ,sex char(1));
insert into eligable
values(012403186,"M")
values(022503199,"F")
values(032503199,"M")
values(042503199,"M")
values(052503199,"F")
values(062503199,"F")
values(072503199,"M")
values(082503199,"F")
values(092503199,"M")
values(102503199,)
values(112503199,"M");
quit;

proc SQL;
create table eligable2
(ssn num
 ,sex char(1));
insert into eligable
values(012403186,"M")
values(022503199,"F")
values(032503199,"M")
values(042503199,"M")
values(052503199,"F")
values(062503199,"F")
values(072503199,"M")
values(082503199,"F")
values(092503199,"M")
values(102503199,"F")
values(112503199,"M");
quit;

proc SQL;
create table Attended
(ssn num
,sex Char(1));
insert into Attended
values(042503199,"M")
values(082503199,"F");
quit;

*scientific notation problem and fix;
proc SQL ;
select ssn into :SSNAttnded separated by "," from attended;
quit;
%put  &SSNAttnded;

proc format ;
value $GNDR 'M'='Male' 'F'='Female';run;

options nocenter;
Proc SQL;
select Name , sex format=$GNDR.
from MyClass;
run;

proc sql;
select distinct(sex) into :sexlist separated by ' '
from MyClass;
%put &sexlist;

proc sql;
select distinct(Age) into :AgeList separated by ' '
from MyClass;
%put &AgeList;


%macro Failures;
proc sql; 
/*can concatinate strings inside a distinct but Format is not applied.
  can have complex separators*/
select distinct('"'||sex||'"') format=$GNDR. 
        into :sexlist separated by ' and sex NE '
from MyClass;
%put &sexlist;

%let sexlist=;
proc sql; /*syntax Error fails to run */
select distinct('"'||sex format=$GNDR.||'"')  into :sexlist 
      separated by ' and sex NE '
from MyClass;
%put &sexlist;
%mend Failures;


%let sexlist=;
proc sql;
title "Close to being right- put first & last quotes in the where";
select distinct(sex) format=$GNDR. into :sexlist separated by '" , "'
from MyClass;
%put &sexlist;

%let sexlist=;
proc sql;/*Fails format must be outside the distincting parenthesis*/
select distinct(sex format=$GNDR.) into :sexlist separated by '","'
from MyList;
%put &sexlist;

%mend Failures;

***Value into one variable;
%let namelist=;
proc sql noprint;
SELECT max(age) INTO :MaxAge 
FROM MyClass;
quit;
%PUT &MaxAge; 

***Column into one variable;
%let namelist=;
proc sql noprint;
SELECT quote(NAME) INTO :NAMELIST SEPARATED BY ","
FROM MyClass;
quit;
%PUT &NAMELIST; 


***Column into Several variables;
proc sql noprint;
SELECT distinct(Sex) INTO :Gndr1-:Gndr99
FROM MyClass;
quit;
%PUT &Gndr1 &Gndr2 &Gndr3; 


*******************;
*loading multiple values into multiple macros;
Proc SQL;
select 	name
      	,age 
		,height  
   into :namelist  separated by "*"
        , :agelist separated by " " 
     	, :heightlist separated by "-"
		from sashelp.class;
%put &namelist &agelist &heightlist;


****;
Proc SQL;
select name,sex, age into
	   :name1-:name99
	   ,:sex1-:sex99
       ,:age1-:age99
	   from SAShelp.class;
	   quit;
options nocenter ls=90;
Proc SQL;
select scope, name ,value 
from sashelp.vmacro
where upcase(scope)="GLOBAL" and substr(name,1,1) in ("N","S","A")
order by name;run;

*cool creation of a quoted string;
proc sql noprint;
SELECT '"'||TRIM(NAME)||'"' INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
%PUT &NAMELIST; 


%let namelist=;
proc sql noprint;
SELECT quote(NAME) INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
quit;
%PUT &NAMELIST; 

%let namelist=;
proc sql noprint; /*Cooler way to add quotes*/
SELECT quote(TRIM(NAME)) INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
quit;
%PUT &NAMELIST; 


%let namelist=;
proc sql noprint; /*Cooler way to add quotes*/
SELECT distinct quote(TRIM(NAME)) INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
quit;
%PUT &NAMELIST; 


**one pass macro variables ;
proc SQl;
select count(*) as totalPats
       ,sum(sex="M") as males /*Sum and group interact to determine rows*/
       ,sum(sex="F") as females
	   ,(calculated males/ calculated TotalPats) 	as PctM
	   ,(calculated females/ calculated TotalPats) 	as PctF
	   ,sum(Height*(sex="M")) /calculated males 	as M_AV_HT
       ,sum(Height*(sex="F")) /calculated females 	as F_AV_HT
      into 	:TotPats 
			,:CountM
			,:CountF
			,:PctM
			,:PctF
			,:M_av_hgt
			,:F_av_hgt
	from SAShelp.class;/*No group & sumary functoins, so one line in ouptut data set*/
;
quit;
proc print data=sashelp.vmacro;
where scope ="GLOBAL" 
     AND UPCASE(NAME) IN("TOTPATS","COUNTM","COUNTF","PCTM","PCTF","M_AV_HGT","F_AV_HGT" );
run; 

