 Proc SQL;
select R.name, R.sex
        age, height
 from
    Left as L
   Right join
    Right as R
 on left.name =r.name
 and L.sex=R.sex;
/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;


/******************************************************************
Section __: Make files for joining
*******************************************************************/
data left(keep=name sex age)
	right(keep=name sex height);
set MyClass;
if mod(_N_,2)=0 then output Left;
if mod(_N_,3)=0 then output Right;
run;
options nocenter;
Proc Print data=left;
title "Left";
Proc Print data=right;
title "Right";
run;
title ;

/******************************************************************
Section __: Comma verison of inner join
*******************************************************************/
options ls=64;
Proc SQL;
select l.* ,"*", r.* 
 from
   Left as L
   ,
   Right as R
 where left.name =r.name
 and L.sex=R.sex;
 quit;


 options ls=64;
Proc SQL;
select COALESCE(L.NAME,R.NAME)
	   ,COALESCE(L.SEX,R.SEX)
       ,AGE , HEIGHT 
 from
   Left as L
   ,
   Right as R
 where left.name =r.name
 and L.sex=R.sex;
 quit;

 Proc SQL;
select L.NAME
	    ,R.SEX
          ,AGE , HEIGHT 
 from
   Left as L
   ,
   Right as R
 where left.name =r.name
 and L.sex=R.sex;

 /******************************************************************
Section __: Specify inner Join
*******************************************************************/
options ls=100;
Proc SQL;
select L.*, "*", R.*
 from
   Left as L
   Inner join
   Right as R
 on left.name =r.name
 and L.sex=R.sex;

  /******************************************************************
Section __: Specify Left Join
*******************************************************************/
options ls=100;
Proc SQL;
select L.*, "*", R.*

 from
    Left as L
   Left join
    Right as R
 on left.name =r.name
 and L.sex=R.sex;

/******************************************************************
Section __: Specify right Join
*******************************************************************/
options ls=100;
Proc SQL;
select L.*, "*", R.*

 from
    Left as L
   Right join
    Right as R
 on left.name =r.name
 and L.sex=R.sex;

 Proc SQL;
select R.name, R.sex
		,age, height
 from
    Left as L
   Right join
    Right as R
 on left.name =r.name
 and L.sex=R.sex;

 /******************************************************************
Section __: Specify FULL Join
*******************************************************************/
Proc SQL;
select COALESCE(l.name,r.name) 
		,COALESCE(l.sex,r.SEX) 
		,age, height
 from
    Left as L
   FULL join
    Right as R
 on left.name =r.name
 and L.sex=R.sex;

/******************************************************************
Section __: Specify CROSS Join
*******************************************************************/
Proc SQL;
select COALESCE(l.name,r.name) 
		,COALESCE(l.sex,r.SEX) 
		,age, height
 from
    Left as L
   CROSS join
    Right as R
;

Proc SQL;
select 	l.name,r.name 
	   	,l.sex,r.SEX 
		,age, height
 from
    Left as L
   CROSS join
    Right as R
;

/******************************************************************
Section __: Union Join
*******************************************************************/
Proc SQL;
select *
 from
    Left as L
   union join corr
    Right as R
;


/******************************************************************
Section __: Natural Join
*******************************************************************/
Proc SQL;
select *
 from
    Left as L
   Natural join
    Right as R
;



/******************************************************************
Section __: Null  vlaues in joins 
			Any Null matches any null (of the same type
******************************************************************/
data left_Null(keep=name sex age)
   right_Null(keep=name sex height);
set MyClass;
If mod(_N_,4)=0 then name="";
if mod(_N_,2)=0 then output Left_Null;
if mod(_N_,3)=0 then output Right_Null;

Proc Print data=Left_null;
title "Left_Null";
run;
Proc Print data=Right_null;
title "Right_Null";
run;

Proc SQL;
select L.name as LName, L.Sex as LSex, L.Age   as LAge, "*"
	  ,R.name as RName, R.Sex as Rsex, R.Height as RHeight
 from
    Left_null as L
   Inner join
    Right_null as R
	on l.name=r.name;

