Subqueries and Efficiency 



Use the MAX function in a subquery instead of the ALL keyword before the subquery. For example, the following queries produce the same result, but the second query is more efficient: 

 proc sql;
    select * from proclib.payroll
    where salary> all(select salary
                      from proclib.payroll
                      where jobcode='ME3');

 proc sql;
    select * from proclib.payroll
    where salary> (select max(salary)
                   from proclib.payroll
                   where jobcode='ME3');
With subqueries, use IN instead of EXISTS when possible. For example, the following queries produce the same result, but the second query is usually more efficient: 

proc sql;
   select *
      from proclib.payroll p
      where exists (select *
                    from staff s
                    where p.idnum=s.idnum
                       and state='CT');

proc sql;
   select *
      from proclib.payroll
      where idnum in (select idnum
                         from staff
                         where state='CT');
