/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
proc SQl;
create table employees 
  (empno    num
   ,job    char(15)
   ,name   char(15)
   , Supervisor num
  );
insert into employees 
values(1,"1_Pres","Goodnight",.)
values(4,"2_V.P. Sales","Kurd",1)
values(6,"2_V.P. R&D","Church",1)
values(8,"2_CFO","Lee",1)
values(14,"3_Salesman","Wang",4)
values(18,"3_Salesman","Rama",4)
values(26,"3_Chemist","Levin",6)
values(28,"3_Metalurgist","Klien",6)
values(31,"3_Acntg. Mgr","Dowd",8)
values(36,"3_ Acntg. Mgr","Shu",8)
;
;


Select e. empno, e.job, e.name, R.name as supervisor, r.job as supv_job

from employees as e
 inner join 
 employees as R
 on e.supervisor=r.empno
order by supv_job;


proc SQl;
create table Flights 
  (origin    Char(3)
  ,flight    num
  ,Destination  char(3)
  ,time num);
insert into flights 
values("SFO",111,"CHI",240)   /*Chicago FSS*/
values("LAX",111,"CHI",210)   /*Chicago FSS*/
values("LAX",121,"NOH",220)  /*O'hare*/
values("LAX",131,"CAK",266)     /*Akron */
values("CHI",241,"PHL",145)  
values("NOH",201,"PHL",167)
values("CAK",201,"PHL",145)
values("CAK",201,"EWK",145)
;

options nocenter;
proc SQL;
/*create table routes as*/
select  wc.origin as WCStart ,  wc.flight as WCFlight ,wc.time as WCTime ,wc.Destination as WCEnd, "->" as spacer label="#"
       ,ec.origin as ReStart   ,ec.flight as ECFlight ,ec.time as ECTime ,ec.Destination as ECEnd,  (ec.time+wc.time) as TotalTime 
  from flights as wc
  inner join
  flights as ec
  on wc.Destination=ec.origin and WC.origin="LAX" and EC.Destination="PHL"
  order by totalTime desc;
