/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
data MyClass;
set SASHelp.Class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

/**************************************************************************************
quick reports
***************************************************************************************/
**success*;
proc sql;
select "Boys " as Group, name, age, sex
from MyClass
where sex="M"
union
select "GIRLS" as Group, name, age, sex
from MyClass
where sex="F";
quit;


**success*;
proc sql;
create table look2 as
select "Boys" as Group, name, age, sex
from MyClass
where sex="M"
union 
select "GIRLS" as Group, name, age, sex
from MyClass
where sex="F";
quit;

options nocenter;
proc print data=look2;
run;

***;


1  there are         0  unknowns in the data set
3  there are        10  boys in the data set
2  there are         9  Girls in the data set
;

proc SQL;
select "3", "there are", max(0,count(*)) , "boys in the data set"
from MyClass where sex="M"
union all
select "2", "there are", max(0,count(*)) , "Girls in the data set"
from MyClass where sex="F"
union all
select "1", "there are", max(0,count(*)) , "unknowns in the data set"
from MyClass where sex=" "
order by 1;
quit;


proc SQL;
select "3" as r,"there are", max(0,count(*)) , "boys in the data set"
from MyClass where sex="M"
 union corr
select "2" as r, "there are", max(0,count(*)) , "Girls in the data set"
from MyClass where sex="F"
 union corr
select "1" as r, "there are", max(0,count(*)) , "unknowns in the data set"
from MyClass where sex=" "
order by 1;
quit;

/***************************************************************************************
Venn schreier
*****************************************************************************************/
****DIFFERENT VARIABLES*********************;
data class;
set SASHelp.Class;
Name_len=length(left(name));
run;

proc print data=class;
run;

proc SQl;
Create table OneW3VarsNAH as 
	select Name_len 
		,name
		,age
		,height
	From 	CLASS 
	Where age LT 14 and length(name) IN (5,6)
    order by name;

    Create table TwoW3VarsNAW as 
	select Name_len 
		,name
		,age
		,weight
	From 	CLASS
	Where age LT 14 and length(name)in(6,7)
    order by age
	;

proc print data=OneW3VarsNAH;
title "data=OneW3VarsNAH";run;
proc print data=TwoW3VarsNAW;
title "data=TwoW3VarsNAW";run;
run;

/*Union Different variables*/
proc sql;
create table union_different as
 select * 
 from OneW3VarsNAH
union 
 select * 
 from TwoW3VarsNAW
;
quit;
proc print data=Union_different;
title "data=Union_different";	
run;


/*Union ALL Different variables*/
proc sql;
create table union_ALL_different as
 select * 
 from OneW3VarsNAH
union all
 select * 
 from TwoW3VarsNAW
order by name;
;
quit;
proc print data=Union_ALL_different;
title "data=Union_ALL_different";	
run;

/*Union Corresponding Different variables*/
proc sql;
create table union_corr_different as
 select * 
 from OneW3VarsNAH
union corresponding
 select * 
 from TwoW3VarsNAW
order by name;
;
quit;
proc print data=union_corr_different;
title "data=union_corr";	
run;


/*Union ALL Corresponding Different variables*/
proc sql;
create table union_ALL_corr_different as
 select * 
 from OneW3VarsNAH
union all corresponding
 select * 
 from TwoW3VarsNAW
order by name;
;
quit;
proc print data=union_ALL_corr_different;
title "data=union_ALL_corr_different";	
run;


/***OUTER UNION**************;
/*Outer Union  Different variables*/
proc sql;
create table Out_union_different as
 select * 
 from OneW3VarsNAH
outer union 
 select * 
 from TwoW3VarsNAW
order by name;
;
quit;
proc print data=Out_union_different;
title "data=Out_un_different";	
run;

/*Outer Union Corresponding  Different variables*/
proc sql;
create table Out_un_corr_different as
 select * 
 from OneW3VarsNAH
outer union corresponding
 select * 
 from TwoW3VarsNAW
;
quit;
proc print data=Out_un_corr_different;
title "data=Out_un_corr_different";	
run;

/*Outer Union Corresponding all Different variables*/
proc sql;
create table Out_un_corr_all_different as
 select * 
 from OneW3VarsNAH
outer union corresponding all
 select * 
 from TwoW3VarsNAW
;
quit;
proc print data=Out_un_corr_all_different;
title "data=Out_un_corr_all_different";	
run;

/***Intersect  Different variables*************/
proc sql;
create table Intersect_different as
 select * 
 from OneW3VarsNAH
Intersect 
 select * 
 from TwoW3VarsNAW
;
quit;
proc contents data=intersect_different;
run;

proc print data=Intersect_different;
title "Intersect_different";	
run;

/*****Except  Different variables*********/
proc sql;
create table Except_different as
 select * 
 from OneW3VarsNAH
Except 
 select * 
 from TwoW3VarsNAW
order by name;
quit;
proc contents data=Except_different;
run;

proc print data=Except_different;
title "Except_different";	
run;

*****************************************************;
*****************************************************;
****Top file is thin 1 VARIABLES*********************;
data class;
set MyClass;
Name_len=length(left(name));
run;

proc print data=class;
run;

proc SQl;
Create table OneW3VarsNA_T_thin as 
	select Name_len 
		,name
		,age
		/*,height*/
	From 	class 
	Where age LT 14 and length(name) IN (5,6)
    order by name;

    Create table TwoW3VarsNAW_T_thin as 
	select Name_len 
		,name
		,age
		,weight
	From 	class 
	Where age LT 14 and length(name)in(6,7)
    order by age
	;

proc print data=OneW3VarsNA_T_thin;
title "data=OneW3VarsNA_T_thin";run;
proc print data=TwoW3VarsNAW_T_thin;
title "data=TwoW3VarsNAW_T_thin";run;
run;

/*Union top is _thin 1 variables*/
proc sql;
create table union_T_thin as
 select * 
 from OneW3VarsNA_T_thin
union 
 select * 
 from TwoW3VarsNAW_T_thin
order by name;
;
quit;
proc print data=Union_T_thin;
title "data=Union_T_thin";	
run;


/*Union ALL top is thin variables*/
proc sql;
create table union_ALL_T_thin as
 select * 
 from OneW3VarsNA_T_thin
union all
 select * 
 from TwoW3VarsNAW_T_thin
order by name;
;
quit;
proc print data=Union_ALL_T_thin;
title "data=Union_ALL_T_thin";	
run;

/*Union Corresponding Top is thin 1 variable*/
proc sql;
create table union_corr_T_thin as
 select * 
 from OneW3VarsNA_T_thin
union corresponding
 select * 
 from TwoW3VarsNAW_T_thin
order by name;
;
quit;
proc print data=union_corr_T_thin;
title "data=union_corresponding_T_thin";	
run;


/*Union ALL Corresponding top is _thin variables*/
proc sql;
create table union_ALL_corr_T_thin as
 select * 
 from OneW3VarsNA_T_thin
union all corresponding
 select * 
 from TwoW3VarsNAW_T_thin
order by name;
;
quit;
proc print data=union_ALL_corr_T_thin;
title "data=union_ALL_corr_T_thin";	
run;


/***OUTER UNION top is _thin 1 variable **************;
/*Outer Union  Different variables*/
proc sql;
create table Out_union_T_thin as
 select * 
 from OneW3VarsNA_T_thin
outer union 
 select * 
 from TwoW3VarsNAW_T_thin
order by name;
;
quit;
proc print data=Out_union_T_thin;
title "data=Out_un_T_thin";	
run;

/*Outer Union Corresponding top is _thin 1 variable*/
proc sql;
create table Out_un_corr_T_thin as
 select * 
 from OneW3VarsNA_T_thin
outer union corresponding
 select * 
 from TwoW3VarsNAW_T_thin
order by name;
;
quit;
proc print data=Out_un_corr_T_thin;
title "data=Out_un_corr_T_thin";	
run;

/*Outer Union Corresponding all top is _thin 1 variable*/
proc sql;
create table Out_un_corr_all_T_thin as
 select * 
 from OneW3VarsNA_T_thin
outer union corresponding all
 select * 
 from TwoW3VarsNAW_T_thin
 order by name; 
;
quit;
proc print data=Out_un_corr_all_T_thin;
title "data=Out_un_corr_all_T_thin";	
run;

/***Intersect  top is _thin 1 variable *************/
proc sql;
create table Intersect_T_thin as
 select * 
 from OneW3VarsNA_T_thin
Intersect 
 select * 
 from TwoW3VarsNAW_T_thin
;
quit;
proc contents data=intersect_T_thin;
run;

proc print data=Intersect_T_thin;
title "Intersect_T_thin";	
run;

/*****Except  Top file is _thin 1 variable *********/
proc sql;
create table Except_T_thin  as
 select * 
 from OneW3VarsNA_T_thin 
Except 
 select * 
 from TwoW3VarsNAW_T_thin 
order by name;
quit;
proc contents data=Except_T_thin ;
run;

proc print data=Except_T_thin ;
title "Except_T_thin ";	
run;

*****************************************************;
****Top file is Wide 1 VARIABLES*********************;
data class;
set MyClass;
Name_len=length(left(name));
run;

proc print data=class;
run;

proc SQl;
Create table OneW3VarsNAH_T_Wide as 
	select Name_len 
		,name
		,age
		,height
	From 	class 
	Where age LT 14 and length(name) IN (5,6)
    order by name;

    Create table TwoW3VarsNA_T_Wide as 
	select Name_len 
		,name
		,age
		/*,weight*/
	From 	class 
	Where age LT 14 and length(name)in(6,7)
    order by age
	;

proc print data=OneW3VarsNAH_T_Wide;
title "data=OneW3VarsNAH_T_Wide";run;
proc print data=TwoW3VarsNA_T_Wide;
title "data=TwoW3VarsNAW_T_Wide";run;
run;

/*Union top is _Wide 1 variable*/
proc sql;
create table union_T_Wide as
 select * 
 from OneW3VarsNAH_T_Wide
union 
 select * 
 from TwoW3VarsNA_T_Wide
order by name;
;
quit;
proc print data=Union_T_Wide;
title "data=Union_T_Wide";	
run;


/*Union ALL top is _wide 1  variable*/
proc sql;
create table union_ALL_T_wide as
 select * 
 from OneW3VarsNAH_T_wide
union all
 select * 
 from TwoW3VarsNA_T_wide
order by name;
;
quit;
proc print data=Union_ALL_T_wide;
title "data=Union_ALL_T_wide";	
run;

/*Union Corresponding Top _wide 1  variable*/
proc sql;
create table union_corr_T_wide as
 select * 
 from OneW3VarsNAH_T_wide
union corresponding
 select * 
 from TwoW3VarsNA_T_wide
order by name;
;
quit;
proc print data=union_corr_T_wide;
title "data=union_corresponding_T_wide";	
run;


/*Union ALL Corresponding top is _wide 1  variabl*/
proc sql;
create table union_ALL_corr_T_wide as
 select * 
 from OneW3VarsNAH_T_wide
union all corresponding
 select * 
 from TwoW3VarsNA_T_wide
order by name;
;
quit;
proc print data=union_ALL_corr_T_wide;
title "data=union_ALL_corr_T_wide";	
run;


/***OUTER UNION top is _wide 1 variable**************;
/*Outer Union  _wide variables*/
proc sql;
create table Out_union_T_wide as
 select * 
 from OneW3VarsNAH_T_wide
outer union 
 select * 
 from TwoW3VarsNA_T_wide
order by name;
;
quit;
proc print data=Out_union_T_wide;
title "data=Out_un_T_wide";	
run;

/*Outer Union Corresponding top is _wide 1 variable*/
proc sql;
create table Out_un_corr_T_wide as
 select * 
 from OneW3VarsNAH_T_wide
outer union corresponding
 select * 
 from TwoW3VarsNA_T_wide
 order by name;
;
quit;
proc print data=Out_un_corr_T_wide;
title "data=Out_un_corr_T_wide";	
run;

/*Outer Union Corresponding all top is _Wide 1 variables*/
proc sql;
create table Out_un_corr_all_T_Wide as
 select * 
 from OneW3VarsNAH_T_Wide
outer union corresponding all
 select * 
 from TwoW3VarsNA_T_Wide
 order by name;
 ;
quit;
proc print data=Out_un_corr_all_T_Wide;
title "data=Out_un_corr_all_T_Wide";	
run;

/***Intersect  top is _Wide 1 variable *************/
proc sql;
create table Intersect_T_Wide as
 select * 
 from OneW3VarsNAH_T_Wide
Intersect 
 select * 
 from TwoW3VarsNA_T_Wide
;
quit;
proc contents data=intersect_T_Wide;
run;

proc print data=Intersect_T_Wide;
title "Intersect_T_Wide";	
run;

/*****Except  Top file is Wide 1 variables*********/
proc sql;
create table Except_T_Wide  as
 select * 
 from OneW3VarsNAH_T_Wide 
Except 
 select * 
 from TwoW3VarsNA_T_Wide 
order by name;
quit;
proc contents data=Except_T_Wide ;
run;

proc print data=Except_T_Wide ;
title "Except_T_Wide ";	
run;

/*****************************************/
/*************** _same **************************/
/** Schreirer Venn same variables ***/
data class;
set MyClass;
Name_len=length(left(name));
run;

proc print data=class;
run;

proc SQl;
Create table OneW3VarsNAH_SAME as 
	select Name_len 
		,name
		,age
		,height
	From 	class 
	Where age LT 14 and length(name) IN (5,6)
    order by name;

    Create table TwoW3VarsNAH_SAME as 
	select Name_len 
		,name
		,age
		,height
	From 	class 
	Where age LT 15 and length(name)in(6,7)
    order by Name_len
	;

proc print data=OneW3VarsNAH_Same;
title "data=OneW3VarsNAH_Same";run;
proc print data=TwoW3VarsNAH_Same;
title "data=TwoW3VarsNAH_Same";run;
run;

/*Union _Same variables*/
proc sql;
create table union_Same as
 select * 
 from OneW3VarsNAH_Same
union 
 select * 
 from TwoW3VarsNAH_Same
order by name;
quit;
proc print data=Union_Same;
title "data=Union_Same";	
run;


/*Union ALL _same variables*/
proc sql;
create table union_ALL_same as
 select * 
 from OneW3VarsNAH_same
union all 
 select * 
 from TwoW3VarsNAH_same
order by name;
quit;
proc print data=Union_ALL_same;
title "data=Union_ALL_same";	
run;

/*Union Corresponding _same variables*/
proc sql;
create table union_corr_same as
 select * 
 from OneW3VarsNAH_same
union corresponding
 select * 
 from TwoW3VarsNAH_same
 order by name;
;
quit;
proc print data=union_corr_same;
title "data=union_corr_same";	
run;


/*Union ALL Corresponding _same variables*/
proc sql;
create table union_ALL_corr_same as
 select * 
 from OneW3VarsNAH_same
union all corresponding
 select * 
 from TwoW3VarsNAH_same
order by name;
quit;
proc print data=union_ALL_corr_same;
title "data=union_ALL_corr_same";	
run;


/***OUTER UNION**************;
/*Outer Union  Different variables*/
proc sql;
create table Out_un_same
 as
 select * 
 from OneW3VarsNAH_same
outer union 
 select * 
 from TwoW3VarsNAH_same
;
quit;
proc print data=Out_un_same;
title "data=Out_un_same";	
run;

/*Outer Union Corresponding  _same variables*/
proc sql;
create table Out_un_corr_same as
 select * 
 from OneW3VarsNAH_same
outer union corresponding
 select * 
 from TwoW3VarsNAH_same
 order by name
;
quit;
proc print data=Out_un_corr_same;
title "data=Out_un_corr_same";	
run;

/*Outer Union Corresponding all  _same variables*/
proc sql;
create table Out_un_corr_all_same as
 select * 
 from OneW3VarsNAH_same
outer union corresponding all
 select * 
 from TwoW3VarsNAH_same
order by name;
;
quit;
proc print data=Out_un_corr_all_same;
title "data=Out_un_corr_all_same";	
run;

/***Intersect  _same variables*************/
proc sql;
create table Intersect_same as
 select * 
 from OneW3VarsNAH_same
Intersect 
 select * 
 from TwoW3VarsNAH_same
order by name;
quit;
proc contents data=intersect_same;
run;

proc print data=Intersect_same;
title "Intersect_same";	
run;

/*****Except  _same variables*********/
proc sql;
create table Except_same as
 select * 
 from OneW3VarsNAH_same
Except 
 select * 
 from TwoW3VarsNAH_same
order by name;
;
quit;
proc contents data=Except_same;
run;

proc print data=Except_same;
title "Except_same";	
run;
