*Shift table part 1 Creation of (a very small) master table using SQL;

proc SQL;
create table labs
(subjid  char(3)
 ,test   char(3)
 ,visit  num 
 ,value  num
 ,decode char(8)
);
insert into labs
values("001","FFS",1   ,. ,"Missing ")   /*FFs= Fehrer Freckle Scale*/
values("001","FFS",1.2 ,4 ,"Severe  ")
values("002","FFS",1   ,2 ,"Moderate")
values("003","FFS",1   ,3 ,"Many    ")
values("004","FFS",1   ,4 ,"Severe  ")
values("001","FFS",9   ,2 ,"Moderate")   /*FFs= Fehrer Freckle Scale*/
values("002","FFS",9   ,. ,"Missing ")
values("002","FFS",9.2 ,2 ,"Moderate")
values("003","FFS",9   ,0 ,"Normal  ")
values("004","FFS",9   ,2 ,"Moderate")
;

Proc SQL;
create table MasterTbl as
select FU_val-Base_Val as diff
       	,coalesce(Baseline.subjid,FU.subjid) as subjid
		,coalesce(Baseline.Test,FU.Test)  as test
		,Baseline.Base_visit,Baseline.Base_Val, Baseline.Base_Decode
		,FU.FU_visit,FU.FU_Val, FU.FU_Decode
from
  (select subjid, test, visit as Base_visit, value as Base_Val, decode as Base_Decode
  from labs
  where 1 <= Base_visit < 2 
  group by subjid 
  having Base_visit =max(Base_visit) 
  ) as Baseline
full join
 (select subjid, test, visit as FU_visit , value as FU_Val, decode as FU_Decode
  from labs
  where 9 <= FU_visit < 10 
  group by subjid 
  having FU_visit =max(FU_visit) 
  ) as FU
  on Baseline.subjid= FU.subjid and Baseline.test= FU.test;
 
  proc print data=MasterTbl;
  run;
 











/******************************************************************
Section __:

There is a Disconnect here!!!!
The example above does not mathc the example belwo- they are independent. 





*******************************************************************/











/*************************************************************************
*        USER ID: MYSELF
*       FILE ID:  Shift_table_SQL.SAS
*      USER NAME: RML (russ@russ-lavery.com)
*      DRUG NAME: 
*       PROTOCOL: 


*     WIN NUMBER: 
*     DATE START: 28-Sep-2004
*  DATE COMPLETE: 28-Sep-2004
*  LAST MODIFIED:
*  INPUT DATASET:  INTERNAL
* OUTPUT DATASET:
*    DESCRIPTION: This shows one way to do a Shift (Before-after) (from-to) table.
*                 It is A CROSSOVER STUDY, to make things more complex;
*                 Not shown , is the creation of the data set combined- this might be complex.
*                 Combined contains all the logic of the problem as implemented as flag variables.
*   The study structure is:
       randomization - baseline1 measurement - period 1 treatments - end1 measurement 
             washout period
       baseline 2 measurement - period 2 treatments- end2 measurement
     flags are:
        Safety 1 =did the person get dosed in period 1? if No, client says not in safety;
        Safety 2 =did the person get dosed in period 2? if No, client says not in safety;
        Baseline1 End1 Baseline2 End2 = some physical measurement at Low, Nrml and High 
        Treat1 and Treat2 are the treatments for periods 1 and 2 and corresrpond to sequence.
        Finish1 and Finish2 tell if the subject finished all treatments in the period.  
                Client says we do not report on subject for periods where finish=  N. 
*************************************************************************/
%let pgmNme=Shift_table_SQL.SAS;
data Combined;  
/*make a data set of the from-to information.  
  One line per "countable thing- thing can be person or or period*/
infile datalines missover firstobs=2;
input @1 subj       $char2. 
      @5 sex        $char1.
      @9 treat      $char2. 
      @17 Safety1   $char1. 
      @25 Baseline1 $char4.
      @35 end1      $char4.
      @42 Finish1   $char1.
      @51 Treat1    $char1.
      @62 Safety2   $char1. 
      @70 Baseline2 $char4.
      @78 end2      $char4.
      @85 Finish2   $char1.
      @93 Treat2    $char1.;
If treat ="AP" then 
   do; /* make a column of treatment and active*/
    Base_act=baseline1;
    end_act =end1;
    Finish_act=finish1;
    Safety_act=safety1;
    Base_Plac=baseline2;
    end_Plac =end2;
    Finish_Plac=finish2;
    Safety_Plac=safety2;
   end;
Else If treat ="PA" then 
   do;
    Base_act=baseline2;
    end_act =end2;
    Finish_act=finish2;
    Safety_act=safety2;
    Base_Plac=baseline1;
    end_Plac =end1;
    Finish_Plac=finish1;
    Safety_Plac=safety1;
   end;
else Put "bad treat code";
LABEL SAFETY1  ="DID SUBJ GET ANY TREATMENT IN PERIOD1";
LABEL SAFETY2  ="DID SUBJ GET ANY TREATMENT IN PERIOD1";
LABEL BASELINE1="LEVEL AT START OF PERIOD 1";
LABEL BASELINE2="LEVEL AT START OF PERIOD 2";
LABEL END1     ="LEVEL AT END OF PERIOD 1";
LABEL END2     ="LEVEL AT END OF PERIOD 2";
LABEL Finish1  ="DID SUBJ FINISH ALL TX IN PERIOD1";
LABEL Finish2  ="DID SUBJ FINISH ALL TX IN PERIOD2";
LABEL TREAT1   ="DRUG RECEIVED IN  PERIOD1";
LABEL TREAT2   ="DRUG RECEIVED IN PERIOD2";
LABEL TREAT    ="ACTIVE-PLACEBO SEQUENCE: AP OR PA";
*The data below would be created by merging several panels;
*One value of creating the dataset below is it allows for easy QC. Everything is in one place; 
*Printing and tabulating this dataset is like a SUPER-listing of the data;
*AS CAN BE SEEN BELOW- THE DATA CAN BE COMPLEX AND DIFFICULT TO QC IS USING SEVERAL SOURCES;
datalines;
Sub sex treat  Safety1  baseline1 end1 Finish1  treat1     safety2 baseline2 end2 finish2 treat2  
01  M   AP      Y       LOW       HIGH   Y        A          Y       NRML    HIGH   Y       P     
02  F   AP      Y       NRML      LOW    Y        A          Y       LOW     HIGH   Y       P     
03  M   AP      Y       LOW       LOW    Y        A *NO 2  *                        N       P    
04  F   PA      Y       NRML      LOW    Y        P          Y       LOW     NRML   Y       A     
05  M   PA      Y       LOW              N        P * BACK * Y       HIGH    NRML   Y       A     
06  F   PA      Y       HIGH      HIGH   Y        P          Y       NRML    LOW    Y       A     
07  M   PA      N       LOW       LOW    Y        P *LEFT 2* Y       NRML           N       A   
08  F   AP      Y       LOW       NRML   Y        A          Y       LOW     NRML   Y       P     
09  M   PA      Y       NRML      LOW    Y        P          Y       NRML    LOW    Y       A     
10  F   AP      Y       HIGH             N        A *LEFT 1*                                  
;
run;

OPTIONS NOCENTER PS=100;
PROC TABULATE DATA=COMBINED MISSING FORMAT=4.;
TITLE "THIS SHOWS ALL CLASS. VARS. ON ALL SUBJECTS - ANWSERS ARE HERE ...BUT HARD TO READ";
CLASS TREAT TREAT1 TREAT2 BASELINE1 SAFETY1 FINISH1 BASELINE2 SAFETY2 FINISH2 END1 END2;
TABLE TREAT*TREAT1*BASELINE1*SAFETY1*FINISH1 ALL 
     TREAT*TREAT2*BASELINE2*SAFETY2*FINISH2 ALL
        ,END1 ALL END2 ALL/RTS=60;RUN;
/*********************************************************************************************/
* get counts of qualified subjects (safety=yes and completed=yes) into macro variables;
data look (keep= treat safety1 safety2 finish1 finish2 all_act all_plac ap_act ap_plac pa_plac pa_act);
set COMBINED end=EOF;
if /*sub was active in period 1 or 2, if subj finished the period, count towards active pats*/
(Treat="AP" and (Safety1="Y" and Finish1="Y")) OR (Treat="PA" and (Safety2="Y" and Finish2="Y")) then all_act+1; 
if /*sub was placebo in period 1 or 2, if subj finished the period, count towards placebo pats*/
(Treat="AP" and (Safety2="Y" and Finish2="Y")) OR (Treat="PA" and (Safety1="Y" and Finish1="Y")) then all_Plac+1; 

if (Treat="AP" and (Safety1="Y" and Finish1="Y"))  then AP_act+1; /*count this subject AP patterna and finished active*/
if (Treat="AP" and (Safety2="Y" and Finish2="Y"))  then AP_Plac+1;/*count this subject AP patterna and finished Placebo*/ 

if (Treat="PA" and (Safety1="Y" and Finish1="Y"))  then PA_Plac+1; /*See above*/
if (Treat="PA" and (Safety2="Y" and Finish2="Y"))  then PA_Act+1;  /*See above*/

if EOF then
  do;  /*load values into macro vars for use in headers*/
   call symput("all_act", trim(left(put(all_act,3. ) ) ));
   call symput("all_Plac",trim(left(put(all_Plac,3.) ) ));
   call symput("AP_act",  trim(left(put(AP_act,3.  ) ) ));
   call symput("AP_Plac", trim(left(put(AP_Plac,3. ) ) ));
   call symput("PA_act",  trim(left(put(PA_act,3.  ) ) ));
   call symput("PA_Plac", trim(left(put(PA_Plac,3. ) ) ));
  end;
run;

/************************************************************************************************
*Divide the report into six sections.  A typical section is shown below, and is easy to code.  
*We will assemble sections towards the end of the program. 
*Since "inside the sections must sum to 100%" and will have different Ns for each section
     - we use proc freqs for each section - not required taht we do so, but common
*since we have counts in macros, a sql would also work.
* think of assembling columns of data like: 
        name FROMLNH     ActiveL   ActiveNML   ActiveH     PlaceboL   PlaceboNML   PlaceboH
        AB   From Low   X ( XX.X)  X ( XX.X)  X ( XX.X)         This would be
             From Nrml  X ( XX.X)  X ( XX.X)  X ( XX.X)        another section
             From High  X ( XX.X)  X ( XX.X)  X ( XX.X)

***************** Shell Data set **************************************************************
*since there is no assurance that every  From -level will be in the data 
       We use a shell to insure all "row" entreis are in the final data set;
* since we'll do a lot of merging - use col3 to col8 for var names (not activeL) ;
***********************************************************************************************/
data shell(sortedby= out_ord int_ord);
length Name $ 8. From_V $ 4 col3-col8 $12 ;
retain col3-col8  "  0 ( 00.0)";
infile datalines missover;
input  @1  name    $char9.
       @13 From_V $char4.  
       @19 out_ord 1. 
       @21 int_ord 1.;
datalines ;
ALL               1 0                                                     
ALL         LOW   1 1                                                   
ALL         NRML  1 2                                                    
ALL         HIGH  1 3                                                   
ACT-PLAC          2 0                                                    
ACT-PLAC    LOW   2 1                                                    
ACT-PLAC    NRML  2 2                                                     
ACT-PLAC    HIGH  2 3                                                     
PLAC-ACT          3 0                                                     
PLAC-ACT    LOW   3 1                                                     
PLAC-ACT    NRML  3 2                                                     
PLAC-ACT    HIGH  3 3                                                     
;
run;

/*%let dsn=combined ;*/
/*%let out_nm=act_all ;*/
/*%let outorder=1                                  ;*/
/*%let base   =Base_act                                      ;*/
/*%let end    =end_act                                       ;*/
/*%let where  =%str(where  safety_act='Y' and finish_act='Y');*/
/*%let COMMENT=ALL Active                                   ;*/
/*%let DENOM=&all_act  ; */

%macro A_SQL(dsn=combined                                /* input data set*/
  ,out_nm =act_all                                       /*name ouf output data set*/  
  ,outorder=1                                  /*vertical order of this section on the page*/
  ,base   =Base_act                                     /* the from variables set*/
  ,end    =end_act                                       /* the ending variable   */ 
  ,denom=&all_act   
  ,where  =where safety_act='Y' and finish_act='Y' /* logic for inclusion/exclusion*/ 
  ,COMMENT=ALL Active                                   /* a reminder of why this structure*/
  );
 
PROC SQL  ;
create table &out_nm as 
select  &outorder as out_ord
       ,"&COMMENT" AS COMMENT
       ,"&WHERE" AS WHERE
       , &base. as from_v 
       , &end.  as to_v 
       , put(count(*),3.0)||" ( "||put((100*count(*)/&denom),4.1)||")" as col
       FROM &dsn
       &where 
GROUP BY comment, out_ord, from_v, to_v  
; 
run;

proc transpose data=&out_nm
  out=&out_nm(drop=_name_)
  prefix=T_;
  var col;
  id to_v;
  by comment out_ord from_v;
run;
%mend A_SQL;

%put _user_;

options mlogic mprint symbolgen;
%A_SQL(dsn=combined                                 /* input data set*/
       ,out_nm =act_all                                       /*name ouf output data set*/  
       ,outorder=1                                  /*vertical order of this section on the page*/
       ,base   =Base_act                                        /* the from variables set*/
       ,end    =end_act                                          /* the ending variable   */
       ,denom=&all_act 
                                      /*put the Y or N in single quotes*/
       ,where  =%str(where  safety_act='Y' and finish_act='Y') /* logic for inclusion/exclusion*/ 
       ,COMMENT=ALL Active                                   /* a reminder of why this structure*/
       );

options mlogic mprint symbolgen;
%A_SQL(dsn=combined                                 /* input data set*/
       ,out_nm =plac_all                                       /*name ouf output data set*/  
       ,outorder=1                                  /*vertical order of this section on the page*/
       ,base   =Base_plac                                      /* the from variables set*/
       ,end    =end_plac                                         /* the ending variable   */  
       ,denom=&all_Plac 
                     /*put the Y or N in single quotes*/
       ,where  =%str(where  safety_plac='Y' and finish_plac='Y') /* logic for inclusion/exclusion*/ 
       ,COMMENT=ALL placebo                                  /* a reminder of why this structure*/
       );
/******/
%A_SQL(dsn=combined                                 /* input data set*/
       ,out_nm =act_AP                                       /*name ouf output data set*/  
       ,outorder=2                                  /*vertical order of this section on the page*/
       ,base   =Baseline1                                        /* the from variables set*/
       ,end    =end1                                          /* the ending variable   */  
       ,denom=&AP_ACT 
                                  /*put the treat, Y or N in single quotes*/
       ,where  =%str(where treat='AP' and  safety1='Y' and finish1='Y') /* logic for inclusion/exclusion*/ 
       ,COMMENT=AP Active                                   /* a reminder of why this structure*/
       );

%A_SQL(dsn=combined                                 /* input data set*/
       ,out_nm =Plac_AP                                       /*name ouf output data set*/ 
       ,outorder=2                                  /*vertical order of this section on the page*/
       ,base   =Baseline2                                        /* the from variables set*/
       ,end    =end2                                          /* the ending variable   */  
       ,denom=&AP_PLAC 
                          /*put the treat, Y or N in single quotes*/ 
       ,where  =%str(where  treat='AP' and  safety2='Y' and finish2='Y') /* logic for inclusion/exclusion*/ 
       ,COMMENT=AP placebo                                   /* a reminder of why this structure*/
       );
/******/
%A_SQL(dsn=combined                                 /* input data set*/
       ,out_nm =act_PA                                       /*name ouf output data set*/  
       ,outorder=3                                  /*vertical order of this section on the page*/
      ,base   =Baseline2                                        /* the from variables set*/
       ,end    =end2                                          /* the ending variable   */  
       ,denom=&PA_ACT 
                        /*put the treat, Y or N in single quotes*/ 
       ,where  =%str(where  treat='PA' and  safety2='Y' and finish2='Y') /* logic for inclusion/exclusion*/ 
       ,COMMENT=PA Active                                   /* a reminder of why this structure*/
       );

%A_SQL(dsn=combined                                 /* input data set*/
       ,out_nm =Plac_PA                                       /*name ouf output data set*/  
       ,outorder=3                                  /*vertical order of this section on the page*/
       ,base   =Baseline1                                        /* the from variables set*/
       ,end    =end1                                             /* the ending variable   */  
       ,denom=&PA_PLAC
                                /*put the treat, Y or N in single quotes*/  
       ,where  =%str(where  treat='PA' and  safety1='Y' and finish1='Y') /* logic for inclusion/exclusion*/ 
       ,COMMENT=PA placebo                                   /* a reminder of why this structure*/
       );
       ;

*assemble the six sections;
data left3(keep=out_ord int_ord col3-col5);        /*NOTE BELOW**************************************************************/
set Act_all Act_AP  Plac_PA ; /* odd sequences happen*/
    if      from_V="LOW"  then int_ord=1;  
    else if from_V="NRML" then int_ord=2;  
    else if from_V="HIGH" then int_ord=3;  
    col3=T_low;
    col4=T_nrml;
    col5=T_high;
    ;
    run;
proc sort data=left3;
by out_ord int_ord;
run;

data right3(keep=out_ord int_ord col6-col8) ;         /*NOTE BELOW**************************************************************/
set Plac_all Plac_AP  Act_PA ; /* odd sequences happen*/
    if      from="LOW"  then int_ord=1;  
    else if from="NRML" then int_ord=2;  
    else if from="HIGH" then int_ord=3;  
    col6=T_low;
    col7=T_nrml;
    col8=T_high;
    ;
    run;
proc sort data=right3;
by out_ord int_ord;
run;

options ls=120 nocenter;
*Think of the output as a 3 by 2 matrix of reports;
*use SQL, and union, to assemble each of the columns (vertically), use SQL and joins to assemble columns - horizontally; 
proc sql;/*Use union to Asse*/
create table left_3 as
select * from act_all
union all 
select * from act_AP
union all 
select * from Plac_PA
;
create table Right_3 as
select * from Plac_all
union all 
select * from Plac_AP
union all 
select * from Act_PA
run;
create table final as
select s.name, s.from_v, s.out_ord, s.int_ord
       ,coalesce(L.t_low  ,s.col3) as ccol3 
       ,coalesce(L.T_nrml ,s.col4) as ccol4
       ,coalesce(L.T_high ,s.col5) as ccol5  
       ,coalesce(R.t_low  ,s.col6) as ccol6 
       ,coalesce(R.T_nrml ,s.col7) as ccol7
       ,coalesce(R.T_high ,s.col8) as ccol8  
     from shell as s
     left join left_3 as L 
     	on s.out_ord=L.out_ord and s.from_v=l.from_V 
     left join Right_3 as R 
     	on s.out_ord=R.out_ord and s.from_v=R.from_V 
order by out_ord, int_ord;
quit;


options ls=110;
*use proc report to make the output pretty;
proc report data= final nowd noheader out=hope;
title "&pgmnme";
where int_ord NE 0;
columns   Name From_v  Ccol3 Ccol4 Ccol5    Ccol6 Ccol7 Ccol8; 
        define Name     /order order=data NOPRINT ;  /*section order in report*/
        define From_v  /order order=data ;  /*internal order in section*/
        define Ccol3 /  display "" ; /*name of the information*/
        define Ccol4 /  display  "";
        define Ccol5 /  display  "";
        define Ccol6 /  display spacing=12 "" ;
        define Ccol7 /  display "";
        define Ccol8 /  display "";
   compute before name ;
     if  name="ALL" then 
     do; 
     spanner ="                                           All Subjects - Before or After Crossover" ;            
     col_head="                       Active Drug(N=&all_act)                             Placebo(N=&all_plac) ";     end; 
    Else if name="ACT-PLAC" then
     do;
     spanner="                                           AP  Subjects - Before or After Crossover"         ;            
     col_head="                        Active Drug(N=&AP_act)                             Placebo(N=&AP_plac) ";
     end;
    else if name="PLAC-ACT" then
     do;
     spanner="                                           PA  Subjects - Before or After Crossover"         ;            
     col_head="                         Placebo(N=&PA_Plac)                                 Active(N=&PA_Act) ";
     end;
    Line @1 spanner  $char105.; 
    Line @1 col_head $char105.;
    Line @1 "          To Low        To Normal     To High                 To Low        To Normal    To High     ";
    Line @1 "From   _____________________________________________________________________________________________";
    endcomp name;

    compute AFTER name ;
    Line @1 " "  ; 
    Line @1 " " ;
    Line @1 "  ";
    Line @1 "  ";
    Line @1 "  ";
    endcomp ;
 run;
