proc SQL;
create table eligable
(ssn num
 ,sex char(1));
insert into eligable
values(012403186,"M")
values(022503199,"F")
values(032503199,"M")
values(042503199,"M")
values(052503199,"F")
values(062503199,"F")
values(072503199,"M")
values(082503199,"F")
values(092503199,"M")
values(102503199,)
values(112503199,"M");
quit;

proc SQL;
create table eligable
(ssn num
 ,sex char(1));
insert into eligable
values(012403186,"M")
values(022503199,"F")
values(032503199,"M")
values(042503199,"M")
values(052503199,"F")
values(062503199,"F")
values(072503199,"M")
values(082503199,"F")
values(092503199,"M")
values(102503199,"F")
values(112503199,"M");
quit;

proc SQL;
create table Attended
(ssn num
,sex Char(1));
insert into Attended
values(042503199,"M")
values(082503199,"F");
quit;

*scientific notation problem and fix;
proc SQL ;
select ssn into :SSNAttnded separated by "," from attended;
quit;
%put  &SSNAttnded;

proc format ;
value $gendr   	M="Male"
				F="Female";
quit;

proc sql;
select distinct(sex) format=$gendr. into :sexlist separated by ' and sex NE '
from attended;
%put &sexlist;



proc sql; 
/*can concatinate strings inside a distinct but Format is not applied.
  can have complex separators*/
select distinct('"'||sex||'"') format=$gendr. 
        into :sexlist separated by ' and sex NE '
from attended;
%put &sexlist;

%let sexlist=;
proc sql; /*syntax Error fails to run */
select distinct('"'||sex format=$gendr.||'"') format=$gendr. into :sexlist 
      separated by ' and sex NE '
from attended;
%put &sexlist;


proc sql;
select distinct(sex) format=$gendr. into :sexlist separated by '","'
from attended;
%put &sexlist;


proc sql;/*Fails format must be outside the distincting parenthesis*/
select distinct(sex format=$gendr.) into :sexlist separated by '","'
from attended;
%put &sexlist;

proc sql;
select distinct('"'||sex format=$gendr. into :sexlist separated by '","'
from attended;
%put &sexlist;



proc sql;
select distinct(sex) format=$gendr. into :sexlist separated by '","'
from attended;
%put &sexlist;


*******************;
*loading multiple values into multiple macros
proc sql;
select 	name
      	,age 
		,height  
   into :namelist  separated by "*"
        , :agelist separated by " " 
     	, :heightlist separated by "-"
		from sashelp.class;
%put &namelist &agelist &heightlist;


****;
Proc SQL;
select name,sex, age into
	   :name1-:name99
	   ,:sex1-:sex99
       ,:age1-:age99
	   from SAShelp.class;
	   quit;
options nocenter ls=150;
Proc print data=sashelp.vmacro;
where upcase(scope)="GLOBAL";
run;

*cool creation of a quoted string;
proc sql noprint;
SELECT '"'||TRIM(NAME)||'"' INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
%PUT &NAMELIST; 


%let namelist=;
proc sql noprint;
SELECT quote(NAME) INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
quit;
%PUT &NAMELIST; 

%let namelist=;
proc sql noprint; /*Cooler way to add quotes*/
SELECT quote(TRIM(NAME)) INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
quit;
%PUT &NAMELIST; 


%let namelist=;
proc sql noprint; /*Cooler way to add quotes*/
SELECT distinct quote(TRIM(NAME)) INTO :NAMELIST SEPARATED BY ","
FROM SASHELP.cLASS;
quit;
%PUT &NAMELIST; 


**one pass macr variables ;
proc SQl;
select count(*) as totalPats
       ,sum(sex="M") as males /*Sum and group interact to determine rows*/
       ,sum(sex="F") as females
	   ,(calculated males/ calculated TotalPats) 	as PctM
	   ,(calculated females/ calculated TotalPats) 	as PctF
	   ,sum(Height*(sex="M")) /calculated males 	as M_AV_HT
       ,sum(Height*(sex="F")) /calculated females 	as F_AV_HT
      into 	:TotPats 
			,:CountM
			,:CountF
			,:PctM
			,:PctF
			,:M_av_hgt
			,:F_av_hgt
	from SAShelp.class;/*No group & sumary functoins, so one line in ouptut data set*/
;
quit;
proc print data=sashelp.vmacro;
where scope ="GLOBAL" 
     AND UPCASE(NAME) IN("TOTPATS","COUNTM","COUNTF","PCTM","PCTF","M_AV_HGT","F_AV_HGT" );
run; 

/*****************************************************************
Section __:Subqueries in the From, Where , Having and in the Select clauses
******************************************************************/
***subqueries in the From are an AD-HOC VIEW *******************;
proc sql;
select * from (select Name,sex, age, age*12 as age_mo 
					from sashelp.class 
						where sex="F")
order by age, name;


**join tow tables from the movie data set;



************subqueries in the where  ******;
proc sql;
create table WonderIF 
(Fname char(20)
,Lname char(20)
);
insert into WonderIF
values ("Elizabeth","Bennett")
values ("Mr.","Darcy")
values ("Colonel","Fitzwilliams")
values ("Hans","Solo")
values ("Adrain","Messinger")
values ("R2","D2")
;

proc sql;
create table BigList
(Fname char(20)
,Lname char(20)
);
insert into BigList
values ("Elizabeth","Bennett")
values ("Mr.","Darcy")
values ("Colonel","Fitzwilliams")
values ("Madam","X")
;





Proc SQL;
select distinct lname from BigList;
; 

Proc SQL;
Select W.* from WonderIF as W 
where W.Lname in (select distinct lname from BigList);
; 

Proc SQL;
Select W.* from WonderIF as W 
where W.Lname NOT in (select distinct lname from BigList);
; 


Proc SQL;
Select W.* from WonderIF as W 
where W.fname, W.Lname NOT in (select distinct fname, lname from BigList);
; 





**SUBQUERIES IN THE SELECT*******************************;
Proc SQL;
select O.name , O.age, O.sex, (select max(age) from MyClass) as MA
        , O.age-(select avg(age) from SAShelp.class as I
                  where O.sex=I.sex ) as Diff_from_Sex_avg_age
        ,(select avg(age) from MyClass as I
                  where O.sex=I.sex ) as Sex_avg_age
from MyClass as O;

Proc SQL;
select O.name , O.age, O.sex 
  ,(select max(age) from MyClass group by sex) as MA
from MyClass as O;
 

**subqueries in  the where;
***find all the people with age =the max age*****;
proc sql; 
select * from MyClass as O /*Outer*/
where o.age = (select max(age) from MyClass);

proc sql; 
select * from MyClass as O /*Outer*/
where o.age IN (select max(age) from MyClass
                group by sex);


proc SQL;
select * from MyClass as O /*outer*/
where 1 = (select count(*) from MyClass as I /*Inner*/
			where O.age=i.age) /*not group , so we return ONE line - 
			           for obs that pass the where clause
			           you can pass several conditoins into the where (to filter obs)
			           but you only return a One by One (one row with one variable) */
order by age;

proc SQL;
select * from MyClass as O /*outer*/
where 1 NE (select count(*) from MyClass as I /*Inner*/
			where O.age=i.age) /*not group , so we return ONE line - 
			           for obs that pass the where clause
			           you can pass several conditoins into the where (to filter obs)
			           but you only return a One by One (one row with one variable) */
order by age;

options ls=130;
proc sql _method _tree; 
/*get the tallest boy and girl in each age group*/
select * from sashelp.class as O /*Outer*/
where o.height = (select max(Height) from SAShelp.CLass as I /*Inner*/
                where o.sex=i.sex and o.age=i.age)
order by sex, age; /*no comfusion with source of sex and age...they come from Outer*/

/******************************************************************
Section __: Having
*******************************************************************/
Proc SQL;
Select name , age 
from MyClass as Outer
having outer.age= (select Max(age)from MyClass as IMax
			where Outer.sex=IMax.sex) 
      or Outer.age= (select Min(age)from MyClass as IMin
			where Outer.sex=IMin.sex)
order by sex, outer.age;
run;

/******************************************************************
Section __: exists
*******************************************************************/
Proc SQL;
select name, sex, age
 from MyClass as outer
 where exists (Select * from MyClass as inner 
 				where inner.age GE (outer.age+2)
				and inner.sex=outer.sex)
oeder by  sex, age;







/******************************************************************
Section __:   Misc examples
*******************************************************************/
**correlated sub-query in where*******;
proc SQL;
select age, count(*) as KidsInAgeGrp
from SAShelp.class
group by age; /*Asking for one line for every level of age*/


options nocerter;
proc SQL;
select * from sashelp.class as O /*outer*/
where 4 <= (select count(*) from sashelp.class as I /*Inner*/
			where O.age=i.age)
order by age;



proc sql; 
select * from sashelp.class as O /*Outer*/
where o.age = (select Min(age) from SAShelp.CLass);

***find all the people with age =the max age for their sex*****;
proc sql; 
select * from sashelp.class as O /*Outer*/
where o.age = (select max(age) from SAShelp.CLass as I /*Inner*/
                where o.sex=i.sex);

options ls=130;
proc sql _method _tree; 
/*get the tallest boy and girl in each age group*/
select * from sashelp.class as O /*Outer*/
where o.height = (select max(Height) from SAShelp.CLass as I /*Inner*/
                where o.sex=i.sex and o.age=i.age)
order by sex, age; /*no comfusion with source of sex and age...they come from Outer*/

*****subqueries in the having **************************;

 
