/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

/******************************************************************
Section __: counting percenatges of age-sex as percent of sex - counts
*******************************************************************/
*add via a query;
Proc SQL;
create table doubleBoys like Myclass;
insert into doubleboys
	select * from MyClass where sex="M";
insert into doubleboys
	select * from MyClass where sex="M";
proc print data=doubleBoys;
run;


*****Insert Rows  ***************************;
Proc SQL;
create table doubleBoys like Myclass;
insert into doubleboys
	select * from MyClass where sex="M";
proc print data=doubleBoys;
run;

**drop a row**;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

Proc SQL;
Delete 
	from MyClass
	where name like "J%";
proc print data=MyClass;
run; 

**Add a column**;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;
Proc SQL;
alter table MyClass
	add Extra Num label="Extra Column";	

proc print data=MyClass;
run; 


**Drop a column**;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;
Proc SQL;
alter table MyClass
	drop Weight;	

proc print data=MyClass;
run; 

**Modify all rows with the same formula**;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;
Proc SQL;
title "This code causes a warning";
Create table MyClass as
Select Name, sex, age*12 as age , height , weight
	from MyClass;	

proc print data=MyClass;
run; 

**Modify rows with same formula **;
options nocenter;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

Proc SQL;
update  MyClass 
	set age=age*12;
Proc Print data=MyClass;
var name age;
run; 


**Modify rows with different formulas **;
options nocenter;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

Proc SQL;
update  MyClass 
	set age=age*12
	where sex="M";
Proc Print data=MyClass;
var name age;
run; 

**Modify rows with different formulas **;
options nocenter;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;
Proc SQL;
update  MyClass 
	set age=age*
		case age
			when 11 then 2
			when 12 then 10
			when 13 then 100
			else 1.0
		end;

Proc Print data=MyClass;
var name age;
run; 


********modify a column***********;
options nocenter;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;
Proc SQL;
alter table  MyClass 
	modify age format=8.3
		   ,sex lable="Gender";

Proc Print data=MyClass label;
var name age sex;
run; 

********modify a SEVERAL THINGS IN A TABLE***********;
options nocenter;
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;
Proc SQL;
alter table  MyClass
	add born_In  num
	drop weight 
	modify  age format=8.1
		   ,sex label="M or F";
	update MyClass
	set born_in=Year(today())-age;
select * from MyClass;
quit;

Proc Print data=Myclass;
run;
