/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
label Name="Student name";
run;

proc SQL _method _tree; 
select  left(put(sum(sex="F"),2.0) ) as FemCount
	   ,left(put(sum(sex="M"),2.0) ) as MaleCount
       ,avg(height) as AllAvgHeight
       ,avg(age)   as AllAvgAge
       ,sum(height*(sex="F"))/sum(sex="F") as FemAvgH
	   ,sum(height*(sex="M"))/sum(sex="M") as MaleAvgH  
       ,sum(Age*(sex="F"))/sum(sex="F")    as FemAvgAge
	   ,sum(Age*(sex="M"))/sum(sex="M")    as MaleAvgAge  
into   :FemCount             ,:MaleCount 
       ,:AllAvgHeight        ,:AllAvgAge 
       ,:FemAvgH             ,:MaleAvgH  
       ,:FemAvgAge           ,:MaleAvgAge
  from MyClass 
;
%put _user_;
title1 "AllAvgAge=&AllAvgAge  and  AllAvgHeight=&AllAvgHeight";
title2 "FemAvgAge=&FemAvgAge  and MaleAvgAge=&MaleAvgAge";
title3 "FemAvgH=&FemAvgH     and MaleAvgH=&MaleAvgH";
title4 "FemCount=&FemCount   and   MaleCount=&MaleCount";


%put _user_;
title1 "AllAvgAge=&AllAvgAge &  FemAvgAge=&FemAvgAge & MaleAvgAge=&MaleAvgAge" ; 
title2 " AllAvgHeight=&AllAvgHeight & FemAvgH=&FemAvgH   & MaleAvgH=&MaleAvgH";
title3 "FemCount=&FemCount   and   MaleCount=&MaleCount";

/******************************************************************
Section __:
*******************************************************************/
Proc SQL;
create table sample 
	(Phys_ID Char(5)
    , enroll_dt num
		Informat=date7.
		Format  =date12.
    ,Rx  num
    );
insert into sample
values ("00001","17oct91"d,10) 
values ("00002","17Sep91"d,9) ;
Proc SQl;
select * from Sample;


proc SQl;
 create table second like MyClass;
 run;
 Proc SQL;
 describe table Second;
 run;

 proc SQL;
 insert into second
 Select * from MyClass where age in(11,12);
 run;
 Proc SQL;
 select name, age from Second;

 Proc SQL;
 insert into Second
 Values ("Shirley","F",55,58,.);
 run;

 Proc SQL; 
 Select * from Second 
 where age GE 12;
 run;
