
Data ShowFlow;
infile datalines truncover firstobs=2;
input @1 charVarL10 $char10. @15 charVarL20 $char20. @41 charVarL35 $char35.;
datalines;
1234567890123456789012345678901234567890123456789012345678901234567890
A234567890    A6789012345678901234      A1234567890123456789012345678901234 
B234567890    B6789012345678901234      B1234567890123456789012345678901234 
C234567890    C6789012345678901234      C1234567890123456789012345678901234 
;
Proc SQL Flow=15;
select * from ShowFlow;



/******************************************************************
Section __: Reduce the number of obs in the data set: the slide is crowded
*******************************************************************/
data MyClass;
set SAShelp.class;
if mod(_N_,7) in (0,1,2,4,6,7) ;
run;

options nocenter;
Proc SQL inobs=6;
select *, avg(height)
 from MyClass;
run; 

options nocenter;
Proc SQL outobs=6;
select *, avg(height)
 from MyClass;
run; 


Proc SQL;
create index GenAge on MyClass(sex, age);
quit;

options msglevel=I;
Proc SQL ;
select name, sex, age
 from MyClass
 where Sex="M" and age=14;
run; 


Proc SQL feedback;
select *
 from MyClass
 where Sex="M" and age=14;
run; 


Proc SQL number double;
select *
 from MyClass
 where Sex="M" and age in(11,12,13);
run; 

