/******************************************************************
Section __:
*******************************************************************/

Proc SQL;/*pg 90*/
create table Nm_money 
( name char(4)
 ,balance  num ); 

insert into Nm_money  /*pg 92*/ 
 values("russ",.)
 values("joe" ,10000)
 values("Chi" ,60000)
;

Proc SQL;
create table interest as
select name, coalesce(balance,0) a, balance*.05 as interest
from nm_money;
quit;
proc print data=interest;
run;

Proc SQL;
create table interest2 as
select name, coalesce(balance,0) as balance2 , balance2*.05 as interest
from nm_money;
quit;
proc print data=interest2;
run;

Proc SQL;
create table interest3 as
select name, coalesce(balance,0) as balance2 , calculated balance2*.05 as interest
from nm_money;
quit;
proc print data=interest3;
run;


/******************************************************************
Section __:
*******************************************************************/
Proc SQL;
create table Nm_job_Match 
( name char(4)
 ,job  char(5) ); 
insert into Nm_job_Match 
,values("russ","Geek")
,values("joe" ,"Prgmr")
,values("Chi" ,"Mgr.")
;

Proc SQL;
create table Nm_job_Mismatch 
( name char(4)
 ,job  char(5) ); 
insert into Nm_job_Mismatch
values("Russ","Geek")
values("Joe" ,"Prgmr")
values("Chi" ,"Mgr.")
;

Proc SQL;
create table Nm_Time 
( name char(4)
 ,Time_W_Co num ); 
insert into Nm_Time
values("russ",6)
values("Chi" ,8)
;

proc SQL;
create table name_Job_Time_Match as
select 
  coalesce (j.name,T.name) as name
  ,j.job as job
  ,coalesce(t.Time_W_Co,0) as time_w_co
from Nm_job_match as J
	   left join
     Nm_Time as T
	 on j.name=t.name;
	;
	proc print data=name_Job_Time_match;
	run;

proc SQL;
create table name_Job_Time_Mismatch as
select 
  coalesce (j.name,T.name) as name
  ,j.job as job
  ,coalesce(t.Time_W_Co,0) as time_w_co
from Nm_job_Mismatch as J
	   left join
     Nm_Time as T
	 on j.name=t.name;
	;
	proc print data=name_Job_Time_Mismatch;
	run;



/******************************************************************
Section __:
*******************************************************************/
data Yr2004;
infile datalines truncover 
  firstobs=3;
input @1 ID  @5 Name $char6. 
@15 state $char6.;  
Datalines;
ID  Name      State  
12345678901234567890123456789012345678901234567890
001 Bob		  PA2004
005 Carl	  NJ2004
010 Fan       DE2004
011 Mike      PA2004 
;
run;	
data Yr2005;
infile datalines truncover firstobs=3;
input @1 ID  @5 Name   $char6. @15 state $char6.;  
Datalines;
ID  Name      State  
12345678901234567890123456789012345678901234567890
001 Bob		  PA2005
002 Cal       NH2005
005 Carl	  NJ2005
006 Errol     CA2005
020 Sue       NJ2005
;
run;	
data Yr2006;
infile datalines truncover firstobs=3;
input @1 ID @5 Name   $char6. @15 state $char6.;  
Datalines;
ID  Name      State  
12345678901234567890123456789012345678901234567890
001 Robert	  TN2006
002 Calvin    NH2006
005 Carl	  NJ2006
007 Earl      NY2006
008 Ell       DE2006
025 Ted       WI2006
;
run;	


Proc SQL;
create table Yr2006N2005 as
 select
  coalesce(six.ID,Five.ID) as Curr_ID
 ,coalesce(six.name,Five.name) as Curr_name
 ,coalesce(six.State,Five.State) as Curr_Address
 from yr2006 as six
  full join 
   yr2005 as five on six.id=five.ID 
;
options nocenter;
proc print data=Yr2006N2005;
run;



Proc SQL;
create table current as
 select
  coalesce(six.ID,Five.ID,Four.ID) as C_ID
 ,coalesce(six.name,Five.name,Four.name) as C_name
 ,coalesce(six.State,Five.State,Four.State) as C_Addr
 from yr2006 as six
  full join 
   yr2005 as five on six.id=five.ID
  full join
   yr2004 as four on (four.ID=six.ID or four.id=five.id)
   ORDER BY C_ID; 
;
options nocenter;
proc print data=current;
run;


proc sort data=Yr2004;
by id;
run;
proc sort data=Yr2005;
by id;
run;
proc sort data=Yr2006;
by id;
run;

data allyrs;
merge Yr2004 Yr2005 Yr2006;
by ID;
run;
options nocenter;
proc print data=allyrs;
run;
